#ifndef DATEINFOWIDGET_H
#define DATEINFOWIDGET_H

#include <QWidget>
#include <QLabel>
#include <QComboBox>
#include <QLineEdit>

#include "dateselectionwidget.h"

class DateInfoWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DateInfoWidget(QWidget *parent = nullptr);
    ~DateInfoWidget();

private slots:
    void onDateChanged(QDate newDate);
    void onDateFormatChanged(int format);
    void onDateFormatStringChanged(const QString& format);
    void onDeltaChanged(const QString& delta);
    void onIntervalTypeChanged(int type);

private:
    DateSelectionWidget* m_dateSelectWidget;

    QComboBox*  m_dateFormatComboBox;
    QLineEdit*  m_dateFormatStringEdit;

    QLabel* m_dateStringLabel;
    QLabel* m_weekNumberLabel;
    QLabel* m_dayOfWeekLabel;
    QLabel* m_dayOfYearLabel;
    QLabel* m_julianDayLabel;
    QLabel* m_isLeapYearLabel;

    QLineEdit* m_deltaEdit;
    QComboBox* m_intervalTypeComboBox;
    QComboBox* m_beforeAfterComboBox;
    QLabel* m_updatedDateLabel;

    QStringList m_dayList;

    void setupUI();

    void updateUI();
    void updateUIInvalidDate();

    QString getDateString(QDate date) const;
    QString getUpdatedDateString(QDate date) const;
    QString getDayOfWeek(int day) const;
};

#endif // DATEINFOWIDGET_H
