#ifndef DATESELECTIONWIDGET_H
#define DATESELECTIONWIDGET_H

#include <QObject>
#include <QWidget>
#include <QComboBox>
#include <QLineEdit>
#include <QDate>

class DateSelectionWidget : public QWidget
{
    Q_OBJECT
public:
    explicit DateSelectionWidget(QWidget *parent = nullptr);

    QDate getDate() { return m_date; }

signals:
    void dateChanged(QDate);

private slots:
    void onMonthChanged(int month);
    void onDayChanged(int day);
    void onYearChanged(const QString& year);

private:
    QComboBox*  m_monthComboBox;
    QComboBox*  m_dayComboBox;
    QLineEdit*  m_yearLineEdit;

    QDate       m_date;

    void setupUI();
    void updateDayComboBox(int year, int month, int day);
    void updateDate(int year, int month, int day);
};

#endif // DATESELECTIONWIDGET_H
